> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create or update payment profiles in bulk

PUT https://rest.test.zuora.com/v1/payment-profile
Content-Type: application/json

Bulk creates payment profiles or updates payment profiles if they already exist. 

You can create or update a maximum of 50 payment profiles in a single call.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/payments/payment-profiles/upsert-payment-profiles

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects an object.

- `bulkPaymentOptionItems` (list of V1PaymentProfilePutRequestBodyContentApplicationJsonSchemaBulkPaymentOptionItemsItems, optional) — An array of payment profiles you want to create or update.

## Response

### 200

OK

- `success` (boolean, optional) — Indicates whether the operation is successful.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### V1PaymentProfilePutRequestBodyContentApplicationJsonSchemaBulkPaymentOptionItemsItems

- `subscriptionId` (string, optional) — The ID of the subscription associated with the payment profile fields.
- `paymentMethodId` (string, optional) — The ID of the payment method that processes the payment.
- `paymentGatewayId` (string, optional) — The ID of the gateway instance that processes the payment.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "bulkPaymentOptionItems": [
    {
      "subscriptionId": "8ad080f08ed1c780018ed6acc5eb65fd",
      "paymentMethodId": "8ad09be48e5bcc3f018e5f0c0791674d",
      "paymentGatewayId": "8b48f15831445266784be9fb20be9b40"
    },
    {
      "subscriptionId": "2c92c0f86a8dd422016a9e7a70116b0d",
      "paymentMethodId": "8ad0950c8292b8560182a75940b808cd",
      "paymentGatewayId": "8ad086dc88762fc7018876e2a83406ef"
    }
  ]
}
```

**Response**

```json
{
  "success": true
}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/v1/payment-profile"

payload = { "bulkPaymentOptionItems": [
        {
            "subscriptionId": "8ad080f08ed1c780018ed6acc5eb65fd",
            "paymentMethodId": "8ad09be48e5bcc3f018e5f0c0791674d",
            "paymentGatewayId": "8b48f15831445266784be9fb20be9b40"
        },
        {
            "subscriptionId": "2c92c0f86a8dd422016a9e7a70116b0d",
            "paymentMethodId": "8ad0950c8292b8560182a75940b808cd",
            "paymentGatewayId": "8ad086dc88762fc7018876e2a83406ef"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/v1/payment-profile';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"bulkPaymentOptionItems":[{"subscriptionId":"8ad080f08ed1c780018ed6acc5eb65fd","paymentMethodId":"8ad09be48e5bcc3f018e5f0c0791674d","paymentGatewayId":"8b48f15831445266784be9fb20be9b40"},{"subscriptionId":"2c92c0f86a8dd422016a9e7a70116b0d","paymentMethodId":"8ad0950c8292b8560182a75940b808cd","paymentGatewayId":"8ad086dc88762fc7018876e2a83406ef"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/payment-profile"

	payload := strings.NewReader("{\n  \"bulkPaymentOptionItems\": [\n    {\n      \"subscriptionId\": \"8ad080f08ed1c780018ed6acc5eb65fd\",\n      \"paymentMethodId\": \"8ad09be48e5bcc3f018e5f0c0791674d\",\n      \"paymentGatewayId\": \"8b48f15831445266784be9fb20be9b40\"\n    },\n    {\n      \"subscriptionId\": \"2c92c0f86a8dd422016a9e7a70116b0d\",\n      \"paymentMethodId\": \"8ad0950c8292b8560182a75940b808cd\",\n      \"paymentGatewayId\": \"8ad086dc88762fc7018876e2a83406ef\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/payment-profile")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"bulkPaymentOptionItems\": [\n    {\n      \"subscriptionId\": \"8ad080f08ed1c780018ed6acc5eb65fd\",\n      \"paymentMethodId\": \"8ad09be48e5bcc3f018e5f0c0791674d\",\n      \"paymentGatewayId\": \"8b48f15831445266784be9fb20be9b40\"\n    },\n    {\n      \"subscriptionId\": \"2c92c0f86a8dd422016a9e7a70116b0d\",\n      \"paymentMethodId\": \"8ad0950c8292b8560182a75940b808cd\",\n      \"paymentGatewayId\": \"8ad086dc88762fc7018876e2a83406ef\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://rest.test.zuora.com/v1/payment-profile")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"bulkPaymentOptionItems\": [\n    {\n      \"subscriptionId\": \"8ad080f08ed1c780018ed6acc5eb65fd\",\n      \"paymentMethodId\": \"8ad09be48e5bcc3f018e5f0c0791674d\",\n      \"paymentGatewayId\": \"8b48f15831445266784be9fb20be9b40\"\n    },\n    {\n      \"subscriptionId\": \"2c92c0f86a8dd422016a9e7a70116b0d\",\n      \"paymentMethodId\": \"8ad0950c8292b8560182a75940b808cd\",\n      \"paymentGatewayId\": \"8ad086dc88762fc7018876e2a83406ef\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://rest.test.zuora.com/v1/payment-profile', [
  'body' => '{
  "bulkPaymentOptionItems": [
    {
      "subscriptionId": "8ad080f08ed1c780018ed6acc5eb65fd",
      "paymentMethodId": "8ad09be48e5bcc3f018e5f0c0791674d",
      "paymentGatewayId": "8b48f15831445266784be9fb20be9b40"
    },
    {
      "subscriptionId": "2c92c0f86a8dd422016a9e7a70116b0d",
      "paymentMethodId": "8ad0950c8292b8560182a75940b808cd",
      "paymentGatewayId": "8ad086dc88762fc7018876e2a83406ef"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/payment-profile");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"bulkPaymentOptionItems\": [\n    {\n      \"subscriptionId\": \"8ad080f08ed1c780018ed6acc5eb65fd\",\n      \"paymentMethodId\": \"8ad09be48e5bcc3f018e5f0c0791674d\",\n      \"paymentGatewayId\": \"8b48f15831445266784be9fb20be9b40\"\n    },\n    {\n      \"subscriptionId\": \"2c92c0f86a8dd422016a9e7a70116b0d\",\n      \"paymentMethodId\": \"8ad0950c8292b8560182a75940b808cd\",\n      \"paymentGatewayId\": \"8ad086dc88762fc7018876e2a83406ef\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["bulkPaymentOptionItems": [
    [
      "subscriptionId": "8ad080f08ed1c780018ed6acc5eb65fd",
      "paymentMethodId": "8ad09be48e5bcc3f018e5f0c0791674d",
      "paymentGatewayId": "8b48f15831445266784be9fb20be9b40"
    ],
    [
      "subscriptionId": "2c92c0f86a8dd422016a9e7a70116b0d",
      "paymentMethodId": "8ad0950c8292b8560182a75940b808cd",
      "paymentGatewayId": "8ad086dc88762fc7018876e2a83406ef"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/payment-profile")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```